SystemOrganization addCategory: #'FuelMetalevel-Clusters'!
SystemOrganization addCategory: #'FuelMetalevel-Mappers'!
SystemOrganization addCategory: #FuelMetalevel!

FLIteratingCluster subclass: #FLBehaviorCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel-Clusters'!

!FLBehaviorCluster commentStamp: 'MartinDias 7/30/2011 20:31' prior: 0!
I have the common behavior for serializing class and trait behaviors in full detail.!

!FLBehaviorCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
afterMaterializationStepWith: aDecoder

	objects do:	[ :aClassOrTrait | 
		aClassOrTrait fuelInitializeTraitComposition.
		aClassOrTrait fuelAfterMaterialization ]! !

!FLBehaviorCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializePostInstance: aClassOrTrait with: aDecoder

	self subclassResponsibility! !

!FLBehaviorCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializePostInstancesStepWith: aDecoder

	objects do:	[ :aClassOrTrait | self materializePostInstance: aClassOrTrait with: aDecoder ]! !

!FLBehaviorCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeReferencesOf: aClassOrTrait with: aDecoder

	aClassOrTrait methodDictionary: aDecoder nextEncodedReference.
	aClassOrTrait organization: aDecoder nextEncodedReference.
	aClassOrTrait basicLocalSelectors: aDecoder nextEncodedReference.
	aClassOrTrait traitComposition: aDecoder nextEncodedReference.! !

!FLBehaviorCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeReferencesStepWith: aDecoder

	objects do:	[ :aClassOrTrait | self materializeReferencesOf: aClassOrTrait with: aDecoder ]! !

!FLBehaviorCluster methodsFor: 'analyzing' stamp: 'MartinDias 7/30/2011 20:17'!
referencesOf: aClassOrTrait do: aBlock

	aBlock value: aClassOrTrait methodDictionary.
	aBlock value: aClassOrTrait organization.
	aBlock value: aClassOrTrait traitComposition.
	aBlock value: aClassOrTrait basicLocalSelectors.! !

!FLBehaviorCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializePostInstance: aClassOrTrait with: anEncoder

	self subclassResponsibility! !

!FLBehaviorCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializePostInstancesStepWith: anEncoder  

	objects do:	[ :aClassOrTrait | self serializePostInstance: aClassOrTrait with: anEncoder ]! !

!FLBehaviorCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializeReferencesOf: aClassOrTrait with: anEncoder

	anEncoder encodeReferenceTo: aClassOrTrait methodDictionary.
	anEncoder encodeReferenceTo: aClassOrTrait organization. 
	anEncoder encodeReferenceTo: aClassOrTrait basicLocalSelectors.
	anEncoder encodeReferenceTo: aClassOrTrait traitComposition.! !

!FLBehaviorCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializeReferencesStepWith: anEncoder

	objects do:	[ :aClassOrTrait | self serializeReferencesOf: aClassOrTrait with: anEncoder ]! !

FLBehaviorCluster subclass: #FLClassCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel-Clusters'!

!FLClassCluster commentStamp: 'MartinDias 7/30/2011 20:31' prior: 0!
I am a cluster for storing classes in full detail.!

!FLClassCluster class methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 15:36'!
clusterBucketIn: aClusterization

	^aClusterization metalevelInstanceSideBucket! !

!FLClassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeInstanceWith: aDecoder

	| aMetaclass |
	aMetaclass := aDecoder nextEncodedReference.
	^aMetaclass new! !

!FLClassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 20:56'!
materializePostInstance: aClass with: aDecoder

	| superclass category name instanceVariableNames format |
	superclass := aDecoder nextEncodedReference.
	category := aDecoder nextEncodedReference.
	name := aDecoder nextEncodedReference.
	format := aDecoder nextEncodedReference.
	instanceVariableNames := aDecoder nextEncodedString subStrings: ' '.

	aClass 
		superclass: superclass;
		setFormat: format;
		setName: name;
		basicInstVarNames: instanceVariableNames;
		basicCategory: category; 
		methodDict: MethodDictionary new.
		! !

!FLClassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeReferencesOf: aClass with: aDecoder

	super materializeReferencesOf: aClass with: aDecoder.

	aClass classPool: aDecoder nextEncodedReference.
	aClass sharedPools: aDecoder nextEncodedReference.
	aClass environment: aDecoder nextEncodedReference.
	aClass basicSubclasses: aDecoder nextEncodedReference.
	
	Class class instSize + 1 to: aClass class instSize 
		do: [ :index | aClass instVarAt: index put: aDecoder nextEncodedReference ]! !

!FLClassCluster methodsFor: 'analyzing' stamp: 'MartinDias 9/28/2011 19:41'!
referencesOf: aClass do: aBlock

	super referencesOf: aClass do: aBlock.

	aBlock value: aClass classSide.
	aBlock value: aClass superclass.
	aBlock value: aClass basicClassPool.
	aBlock value: aClass basicSharedPools. 
	aBlock value: aClass basicCategory.
	aBlock value: aClass name.
	aBlock value: aClass format.	
	aBlock value: aClass basicEnvironment.
	aBlock value: aClass basicSubclasses.
	
	Class class instSize + 1 to: aClass class instSize 
		do: [ :index | aBlock value: (aClass instVarAt: index) ]! !

!FLClassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializeInstance: aClass with: anEncoder

	anEncoder encodeReferenceTo: aClass classSide! !

!FLClassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 20:02'!
serializePostInstance: aClass with: anEncoder

	anEncoder encodeReferenceTo: aClass superclass.
	anEncoder encodeReferenceTo: aClass basicCategory.
	anEncoder encodeReferenceTo: aClass name.
	anEncoder encodeReferenceTo: aClass format.	
	anEncoder encodeString: aClass instanceVariablesString.
	self flag: #todo. "The array of variable names represents a circularity problem between clusters: if we encode the reference to such array, then the cluster for arrays should be before of Class cluster. But this would disable us to serialize an array of internal classes."
! !

!FLClassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializeReferencesOf: aClass with: anEncoder

	super serializeReferencesOf: aClass with: anEncoder.

	anEncoder encodeReferenceTo: aClass basicClassPool. 
	anEncoder encodeReferenceTo: aClass basicSharedPools. 
	anEncoder encodeReferenceTo: aClass basicEnvironment.
	anEncoder encodeReferenceTo: aClass basicSubclasses.
 
	Class class instSize + 1 to: aClass class instSize 
		do: [ :index | anEncoder encodeReferenceTo: (aClass instVarAt: index) ]! !

FLBehaviorCluster subclass: #FLClassTraitCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel-Clusters'!

!FLClassTraitCluster commentStamp: 'MartinDias 7/30/2011 20:30' prior: 0!
I am a cluster for storing class traits in full detail.!

!FLClassTraitCluster class methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 15:37'!
clusterBucketIn: aClusterization

	^aClusterization metalevelClassSideBucket! !

!FLClassTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeInstanceWith: aDecoder

	^ClassTrait basicNew! !

!FLClassTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializePostInstance: aClassTrait with: aDecoder

	aClassTrait 
		initialize.! !

!FLClassTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 2/17/2012 03:05'!
serializeInstancesStepWith: anEncoder
	"Do nothing. I know my objects have nothing to serialize in this step."
! !

!FLClassTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:44'!
serializePostInstance: aClassTrait with: anEncoder
! !

FLBehaviorCluster subclass: #FLMetaclassCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel-Clusters'!

!FLMetaclassCluster commentStamp: 'MartinDias 7/30/2011 20:30' prior: 0!
I am a cluster for storing metaclasses in full detail.!

!FLMetaclassCluster class methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 15:38'!
clusterBucketIn: aClusterization

	^aClusterization metalevelClassSideBucket! !

!FLMetaclassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeInstanceWith: aDecoder

	^Metaclass new! !

!FLMetaclassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 20:58'!
materializePostInstance: aMetaclass with: aDecoder

	| superclass instanceVariableNames format |
	superclass := aDecoder nextEncodedReference.
	instanceVariableNames := aDecoder nextEncodedString subStrings: ' '.
	format := aDecoder nextEncodedUint16.

	aMetaclass
		superclass: superclass 
		methodDictionary: MethodDictionary new 
		format: format;
		basicInstVarNames: instanceVariableNames.! !

!FLMetaclassCluster methodsFor: 'analyzing' stamp: 'MartinDias 7/29/2011 21:12'!
referencesOf: aMetaclass do: aBlock

	super referencesOf: aMetaclass do: aBlock.
	
	aBlock value: aMetaclass superclass.! !

!FLMetaclassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 2/17/2012 03:05'!
serializeInstancesStepWith: anEncoder
	"Do nothing. I know my objects have nothing to serialize in this step."
! !

!FLMetaclassCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 20:01'!
serializePostInstance: aMetaclass with: anEncoder

	anEncoder encodeReferenceTo: aMetaclass superclass.
	anEncoder encodeString: aMetaclass instanceVariablesString.
	anEncoder encodeUint16: aMetaclass format.
	! !

FLBehaviorCluster subclass: #FLTraitCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel-Clusters'!

!FLTraitCluster commentStamp: 'MartinDias 7/30/2011 20:30' prior: 0!
I am a cluster for storing traits in full detail.!

!FLTraitCluster class methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 15:39'!
clusterBucketIn: aClusterization

	^aClusterization metalevelInstanceSideBucket! !

!FLTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeInstanceWith: aDecoder

	^Trait basicNew! !

!FLTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializePostInstance: aTrait with: aDecoder

	| classTrait category name environment |
	classTrait := aDecoder nextEncodedReference.
	category := aDecoder nextEncodedReference.
	name := aDecoder nextEncodedReference.
	environment := aDecoder nextEncodedReference.
	
	aTrait 
		initialize;
		name: name;
		basicCategory: category asSymbol;
		classTrait: classTrait;
		environment: environment.
	
	classTrait baseTrait: aTrait.! !

!FLTraitCluster methodsFor: 'analyzing' stamp: 'MartinDias 9/16/2011 23:48'!
referencesOf: aTrait do: aBlock

	super referencesOf: aTrait do: aBlock.

	aBlock value: aTrait classSide.
	aBlock value: aTrait basicEnvironment.
	aBlock value: aTrait basicCategory.
	aBlock value: aTrait name.
! !

!FLTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 2/17/2012 03:05'!
serializeInstancesStepWith: anEncoder
	"Do nothing. I know my objects have nothing to serialize in this step."
! !

!FLTraitCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:44'!
serializePostInstance: aTrait with: anEncoder

	anEncoder encodeReferenceTo: aTrait classSide.
	anEncoder encodeReferenceTo: aTrait basicCategory.
	anEncoder encodeReferenceTo: aTrait name.
	anEncoder encodeReferenceTo: aTrait basicEnvironment.
! !

FLIteratingCluster subclass: #FLCompiledMethodCluster
	instanceVariableNames: ''
	classVariableNames: 'TrailerEncoder'
	poolDictionaries: ''
	category: 'FuelMetalevel-Clusters'!

!FLCompiledMethodCluster commentStamp: 'MartinDias 5/30/2011 01:17' prior: 0!
I am a cluster for CompiledMethod instances.!

!FLCompiledMethodCluster class methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 15:37'!
clusterBucketIn: aClusterization

	^aClusterization primitivesBucket! !

!FLCompiledMethodCluster class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 5/11/2012 11:59'!
setTrailerWithNoChange
	^ self trailerEncoder: FLCompiledMethodTrailerEncoderNoChange new.! !

!FLCompiledMethodCluster class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 5/11/2012 11:58'!
setTrailerWithNoSource
	^ self trailerEncoder: FLCompiledMethodTrailerEncoderNoSource new.! !

!FLCompiledMethodCluster class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 5/11/2012 11:59'!
setTrailerWithSourceCode
	^ self trailerEncoder: FLCompiledMethodTrailerEncoderWithSource new.! !

!FLCompiledMethodCluster class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 5/11/2012 11:58'!
trailerEncoder 
	TrailerEncoder isNil ifTrue: [TrailerEncoder := FLCompiledMethodTrailerEncoderNoSource new ].
	^ TrailerEncoder! !

!FLCompiledMethodCluster class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 5/11/2012 11:58'!
trailerEncoder: aTrailerEncoder 
	TrailerEncoder := aTrailerEncoder! !

!FLCompiledMethodCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 20:57'!
materializeInstanceWith: aDecoder

	| compiledMethod header bytecodesPlusTrailerSize |

	header := aDecoder nextEncodedUint32.
	bytecodesPlusTrailerSize := aDecoder nextEncodedUint16.

	compiledMethod := CompiledMethod newMethod: bytecodesPlusTrailerSize header: header.

	compiledMethod initialPC to: compiledMethod size
		do: [ :index | compiledMethod at: index put: aDecoder nextEncodedByte ].
		
	^ compiledMethod! !

!FLCompiledMethodCluster methodsFor: 'protected' stamp: 'MartinDias 12/29/2011 19:48'!
materializeLiteralsTo: compiledMethod with: aDecoder

	1 to: compiledMethod numLiterals 
		do: [ :index | compiledMethod literalAt: index put: aDecoder nextEncodedReference ]
! !

!FLCompiledMethodCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeReferencesStepWith: aDecoder

	objects do: [ :aCompiledMethod | self materializeLiteralsTo: aCompiledMethod with: aDecoder ]! !

!FLCompiledMethodCluster methodsFor: 'analyzing' stamp: 'MartinDias 3/21/2012 19:14'!
referencesOf: aCompiledMethod do: aBlock

	aCompiledMethod fuelPrepare.
	1 to: aCompiledMethod numLiterals
		do: [ :index | aBlock value: (aCompiledMethod literalAt: index) ]! !

!FLCompiledMethodCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 5/11/2012 11:57'!
serializeInstance: aCompiledMethodToSerialize with: anEncoder

	| header bytecodesPlusTrailerSize cmSize cmInitialPC aCompiledMethod |

	aCompiledMethod := self class trailerEncoder compiledMethodToSerialize: aCompiledMethodToSerialize.

	header := aCompiledMethod header.
	cmSize := aCompiledMethod size.
	cmInitialPC := aCompiledMethod initialPC.
	bytecodesPlusTrailerSize := cmSize - cmInitialPC + 1.

	anEncoder 
		encodeUint32: header;
		encodeUint16: bytecodesPlusTrailerSize.	

	cmInitialPC to: cmSize
		do: [ :index | anEncoder encodeByte: (aCompiledMethod at: index) ].! !

!FLCompiledMethodCluster methodsFor: 'protected' stamp: 'MartinDias 3/21/2012 19:14'!
serializeLiteralsOf: aCompiledMethod with: anEncoder

	aCompiledMethod fuelPrepare.
	1 to: aCompiledMethod numLiterals 
		do: [ :index | anEncoder encodeReferenceTo: (aCompiledMethod literalAt: index) ]! !

!FLCompiledMethodCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializeReferencesStepWith: anEncoder

	objects do: [ :aCompiledMethod | self serializeLiteralsOf: aCompiledMethod with: anEncoder ]! !

FLIteratingCluster subclass: #FLGlobalClassPoolAssociationCluster
	instanceVariableNames: 'classOwnerByAssociation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel-Clusters'!

!FLGlobalClassPoolAssociationCluster commentStamp: 'MartinDias 5/30/2011 01:17' prior: 0!
I am a cluster for class variable associations, i.e. bindings that belong to the class pool of a Class included on Smalltalk globals.!

!FLGlobalClassPoolAssociationCluster class methodsFor: 'analyzing' stamp: 'MartinDias 1/8/2012 15:37'!
clusterBucketIn: aClusterization

	^aClusterization baselevelBucket! !

!FLGlobalClassPoolAssociationCluster methodsFor: 'accessing' stamp: 'MartinDias 9/4/2011 23:57'!
classOwnerByAssociation
	^ classOwnerByAssociation! !

!FLGlobalClassPoolAssociationCluster methodsFor: 'accessing' stamp: 'MartinDias 9/4/2011 23:57'!
classOwnerByAssociation: anObject
	classOwnerByAssociation := anObject! !

!FLGlobalClassPoolAssociationCluster methodsFor: 'initialize-release' stamp: 'MartinDias 3/16/2012 22:59'!
declare: anAssociation belongsTo: ownerClass

	classOwnerByAssociation at: anAssociation put: ownerClass! !

!FLGlobalClassPoolAssociationCluster methodsFor: 'initialize-release' stamp: 'MartinDias 1/8/2012 13:23'!
initializeAnalyzing

	super initializeAnalyzing.
	classOwnerByAssociation := IdentityDictionary new.! !

!FLGlobalClassPoolAssociationCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:48'!
materializeInstanceWith: aDecoder

	| keyName ownerClass |
	ownerClass := aDecoder nextEncodedReference.
	keyName := aDecoder nextEncodedReference.
	^ownerClass classPool associationAt: keyName! !

!FLGlobalClassPoolAssociationCluster methodsFor: 'analyzing' stamp: 'MartinDias 9/4/2011 23:56'!
referencesOf: anAssociation do: aBlock

	aBlock 
		value: (classOwnerByAssociation at: anAssociation);
		value: anAssociation key! !

!FLGlobalClassPoolAssociationCluster methodsFor: 'serialize/materialize' stamp: 'MartinDias 12/29/2011 19:43'!
serializeInstance: anAssociation with: anEncoder

	anEncoder 
		encodeReferenceTo: (classOwnerByAssociation at: anAssociation);
		encodeReferenceTo: anAssociation key! !

FLMapper subclass: #FLFullGlobalMapper
	instanceVariableNames: 'clusterByObject globalSymbols globalsCluster instanceSideCluster classSideCluster classVariablesCluster globalAssociationCluster globalCompiledMethodCluster internalMethods internalBehaviors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel-Mappers'!

!FLFullGlobalMapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 5/11/2012 10:39'!
newWithInternalBehaviors: internals internalMethods: methods globalSymbols: globalSymbols

	^self basicNew
		initializeWithInternalBehaviors: internals
		internalMethods: methods 
		globalSymbols: globalSymbols;
		yourself 
		! !

!FLFullGlobalMapper methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 5/20/2012 15:54'!
cacheClassAssociation: anAssociation

	clusterByObject
		at: anAssociation put: globalAssociationCluster;
		at: anAssociation value put: instanceSideCluster;
		at: anAssociation value class put: classSideCluster.
	anAssociation value classPool
		associationsDo: [ :aVariableAssociation | 
			classVariablesCluster 
				declare: aVariableAssociation 
				belongsTo: anAssociation value.
			clusterByObject 
				at: aVariableAssociation 
				put: classVariablesCluster ]! !

!FLFullGlobalMapper methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 4/21/2012 18:12'!
cacheGlobalAssociation: anAssociation
	clusterByObject at: anAssociation put: globalAssociationCluster.	
	"Some globals, like ActiveHand have a nil value in the Smalltalk globals. Therefore, we cannot map nil to globalCluster. We could filter before in #defaultGlobalSymbols but that means that not even the Association will be consider global."
	anAssociation value isNil
		ifFalse: [ clusterByObject at: anAssociation value put: globalsCluster ]! !

!FLFullGlobalMapper methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 5/11/2012 11:01'!
cacheGlobals

	Smalltalk globals associationsDo: [:each | 
		(internalBehaviors includes: each value)
			ifFalse: [
				each value isBehavior 
					ifTrue: [ self cacheClassAssociation: each ].
				each value isTrait
					ifTrue: [ self cacheTraitAssociation: each ]].
		(globalSymbols includes: each key) 
			ifTrue: [
				self cacheGlobalAssociation: each ]].! !

!FLFullGlobalMapper methodsFor: 'initialize-release' stamp: 'MartinDias 3/16/2012 23:08'!
cacheTraitAssociation: anAssociation

	clusterByObject
		at: anAssociation put: globalAssociationCluster;
		at: anAssociation value put: instanceSideCluster;
		at: anAssociation value classSide put: classSideCluster.! !

!FLFullGlobalMapper methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 5/20/2012 15:49'!
initializeWithInternalBehaviors: explicitInternals internalMethods: methods globalSymbols: explicitExternals

	self initialize.
	clusterByObject := FLLargeIdentityDictionary new.
	internalBehaviors := explicitInternals.
	internalMethods := methods.
	globalSymbols := explicitExternals.
	globalsCluster := FLGlobalValueCluster newAnalyzing.
	instanceSideCluster := FLGlobalClassCluster newAnalyzing.
	classSideCluster := FLGlobalClassSideCluster newAnalyzing.
	classVariablesCluster := FLGlobalClassPoolAssociationCluster newAnalyzing.
	globalAssociationCluster := FLGlobalAssociationCluster newAnalyzing.
	globalCompiledMethodCluster := FLGlobalCompiledMethodCluster newAnalyzing.
	self cacheGlobals.! !

!FLFullGlobalMapper methodsFor: 'mapping' stamp: 'MarianoMartinezPeck 5/11/2012 10:57'!
mapAndTrace: anObject

	| aGlobalCluster |
	aGlobalCluster := 
		clusterByObject 
			at: anObject 
			ifAbsent: [ 
				"This is a hack to support correct behavior of globals for methods. This is just to avoid adding all 
				methods to the cache"
				(anObject class == CompiledMethod and: [self shouldConsdierMethodAsGlobal: anObject])
					ifTrue: [ globalCompiledMethodCluster  ]
					ifFalse: [^ next mapAndTrace: anObject ] 
				].

	(self 
		clusterInstanceOf: aGlobalCluster class
		keyInBucket: aGlobalCluster class name 
		factory: [ aGlobalCluster ])
		add: anObject traceWith: analysis
	! !

!FLFullGlobalMapper methodsFor: 'mapping' stamp: 'MarianoMartinezPeck 5/11/2012 12:23'!
shouldConsdierMethodAsGlobal: aCompiledMethod
	"Answers true when aCompiledMethod must be considered global, and false otherwise.
	Global methods are those which are NOT included in the classes considered as internal, nor in the methods consider as internal, nor if they are DoIts."
	^ ((((internalBehaviors includes: aCompiledMethod methodClass) not
		and: [(internalBehaviors includes: aCompiledMethod methodClass theNonMetaClass) not]) 
			and: [(internalMethods includes: aCompiledMethod) not])
				and: [aCompiledMethod isInstalled ])
					and: [aCompiledMethod isDoIt not]! !

!FLAnalyzer methodsFor: '*FuelMetalevel-configuring' stamp: 'MarianoMartinezPeck 5/11/2012 10:53'!
considerInternalAllBehaviors: classes

	internalClasses addAll: classes.
	self useFullMappers.! !

!FLAnalyzer methodsFor: '*FuelMetalevel-configuring' stamp: 'MarianoMartinezPeck 5/11/2012 10:43'!
considerInternalAllMethods: methods

	internalMethods addAll: methods.
	self useFullMappers.! !

!FLAnalyzer methodsFor: '*FuelMetalevel-configuring' stamp: 'MarianoMartinezPeck 5/11/2012 10:54'!
considerInternalBehavior: class

	internalClasses add: class.
	self useFullMappers.! !

!FLAnalyzer methodsFor: '*FuelMetalevel-configuring' stamp: 'MarianoMartinezPeck 5/11/2012 10:46'!
considerInternalMethod: aMethod

	internalMethods add: aMethod.
	self useFullMappers.! !

!FLAnalyzer methodsFor: '*FuelMetalevel' stamp: 'MarianoMartinezPeck 5/11/2012 10:40'!
fullGlobalMappers

	^Array with: (FLFullGlobalMapper newWithInternalBehaviors: internalClasses internalMethods: internalMethods globalSymbols: globalSymbols)! !

!FLAnalyzer methodsFor: '*FuelMetalevel-configuring' stamp: 'MartinDias 12/31/2011 00:13'!
useFullMappers

	globalMappersFactory := [self fullGlobalMappers].
	generalMapperFactory := [FLFullGeneralMapper new].! !

!Dictionary methodsFor: '*FuelMetalevel' stamp: 'MarianoMartinezPeck 12/12/2011 16:35'!
identityIncludesAssociation: anAssociation
	^ (self   
	      associationAt: anAssociation key
	      ifAbsent: [ ^ false ]) == anAssociation
! !

!Class methodsFor: '*FuelMetalevel' stamp: 'MartinDias 7/30/2011 18:23'!
basicClassPool
	"Answer nil or the dictionary of class variables."

	^classPool! !

!Class methodsFor: '*FuelMetalevel' stamp: 'MarianoMartinezPeck 6/29/2011 11:04'!
basicEnvironment

	^ environment! !

!Class methodsFor: '*FuelMetalevel' stamp: 'MartinDias 7/30/2011 18:23'!
basicSharedPools
	"Answer nil or a Set of the pool dictionaries declared in the receiver."

	^sharedPools! !

!Class methodsFor: '*FuelMetalevel' stamp: 'MartinDias 5/14/2011 21:44'!
basicSubclasses

	^ subclasses! !

!Class methodsFor: '*FuelMetalevel' stamp: 'MartinDias 5/14/2011 21:45'!
basicSubclasses: anArray

	subclasses := anArray! !

FLLightGeneralMapper subclass: #FLFullGeneralMapper
	instanceVariableNames: 'classCluster'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel-Mappers'!

!FLFullGeneralMapper commentStamp: 'MartinDias 8/7/2011 12:24' prior: 0!
I know how to map an object to its default cluster. I can map every object.!

!FLFullGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 18:33'!
visitClass: aClass

	self mapAndTraceByClusterName: aClass to: FLClassCluster! !

!FLFullGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 18:33'!
visitClassTrait: aClassTrait
	
	self mapAndTraceByClusterName: aClassTrait to: FLClassTraitCluster! !

!FLFullGeneralMapper methodsFor: 'visiting' stamp: 'MarianoMartinezPeck 5/11/2012 12:01'!
visitCompiledMethod: aCompiledMethod
	
	self mapAndTraceByClusterName: aCompiledMethod to: FLCompiledMethodCluster
! !

!FLFullGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 18:33'!
visitMetaclass: aMetaclass

	self mapAndTraceByClusterName: aMetaclass to: FLMetaclassCluster! !

!FLFullGeneralMapper methodsFor: 'visiting' stamp: 'MartinDias 1/9/2012 18:34'!
visitTrait: aTrait

	self mapAndTraceByClusterName: aTrait to: FLTraitCluster! !

!CompiledMethod methodsFor: '*FuelMetalevel' stamp: 'MartinDias 3/21/2012 19:54'!
fuelPrepare
	"Prepare for Fuel serialization."
	
	self isNamedPrimitive ifTrue: [self literals first at: 4 put: 0].
	
	"When the method is a named primitive, the first literal is an array that works as an argument for the VM. The first and second elements represent the module and the name of the primivite. The third element of the array is ignored, it used to be a session ID. The forth element is the primitive index in a externalPrimitiveTable and it is IMPORTANT to put it in zero, otherwise there can be errors. Putting a zero means that the VM will not try to directly execute the primitive from the table and it will always try to load the module. It is the safer thing to do. For more details, read the method #primitiveExternalCall in VMMaker."! !

!Trait methodsFor: '*FuelMetalevel' stamp: 'MartinDias 7/1/2011 04:32'!
basicEnvironment

	^self environment ! !

!TPureBehavior methodsFor: '*FuelMetalevel' stamp: 'MartinDias 8/29/2011 04:06'!
fuelInitializeTraitComposition

	self traitComposition traits do: [:each | each addUser: self]! !

Object subclass: #FLCompiledMethodTrailerEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel-Clusters'!

!FLCompiledMethodTrailerEncoder methodsFor: 'method encoding' stamp: 'MartinDias 5/18/2012 01:11'!
compiledMethodToSerialize: aMethod
	self subclassResponsibility ! !

!FLCompiledMethodTrailerEncoder methodsFor: 'hooks' stamp: 'MartinDias 5/18/2012 01:13'!
fuelAccept: aGeneralMapper
	aGeneralMapper visitSubstitution: self by: nil! !

FLCompiledMethodTrailerEncoder subclass: #FLCompiledMethodTrailerEncoderNoChange
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel-Clusters'!

!FLCompiledMethodTrailerEncoderNoChange methodsFor: 'method encoding' stamp: 'MarianoMartinezPeck 9/23/2011 16:37'!
compiledMethodToSerialize: aCompiledMethod
	^ aCompiledMethod! !

FLCompiledMethodTrailerEncoder subclass: #FLCompiledMethodTrailerEncoderNoSource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel-Clusters'!

!FLCompiledMethodTrailerEncoderNoSource methodsFor: 'method encoding' stamp: 'MarianoMartinezPeck 9/23/2011 23:21'!
compiledMethodToSerialize: aCompiledMethod

	^ aCompiledMethod copyWithTrailerBytes: CompiledMethodTrailer empty.! !

FLCompiledMethodTrailerEncoder subclass: #FLCompiledMethodTrailerEncoderWithSource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel-Clusters'!

!FLCompiledMethodTrailerEncoderWithSource methodsFor: 'method encoding' stamp: 'MarianoMartinezPeck 1/18/2012 20:43'!
compiledMethodToSerialize: aCompiledMethod

	^ aCompiledMethod copyWithTrailerBytes: (CompiledMethodTrailer new sourceCode: aCompiledMethod getSource ).
	! !

Object subclass: #ManifestFuelMetalevel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMetalevel'!

!ManifestFuelMetalevel class methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/20/2012 23:51'!
rejectClasses
^ #()! !

!ManifestFuelMetalevel class methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/20/2012 23:51'!
rejectRules
^ #()! !

!ManifestFuelMetalevel class methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 17:20'!
ruleBadMessageRuleV1FalsePositive
^ #(#('(RGMethodDefinition className: ''FLClassCluster'' selector: #referencesOf:do: isMetaSide: false)' #'2012-04-21T17:20:38.254000001+02:00') #('(RGMethodDefinition className: ''FLClassCluster'' selector: #serializeReferencesOf:with: isMetaSide: false)' #'2012-04-21T17:20:38.270000001+02:00') #('(RGMethodDefinition className: ''FLClassCluster'' selector: #materializeReferencesOf:with: isMetaSide: false)' #'2012-04-21T17:20:38.289+02:00') )! !

!ManifestFuelMetalevel class methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 17:26'!
ruleCodeCruftLeftInMethodsRuleV1FalsePositive
^ #(#('(RGMethodDefinition className: ''FLClassCluster'' selector: #serializePostInstance:with: isMetaSide: false)' #'2012-04-21T17:26:41.049+02:00') )! !

!ManifestFuelMetalevel class methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 17:36'!
ruleLawOfDemeterRuleV1FalsePositive
^ #(#('(RGMethodDefinition className: ''FLClassCluster'' selector: #referencesOf:do: isMetaSide: false)' #'2012-04-21T17:36:40.844000001+02:00') #('(RGMethodDefinition className: ''FLClassCluster'' selector: #serializeReferencesOf:with: isMetaSide: false)' #'2012-04-21T17:36:40.865+02:00') #('(RGMethodDefinition className: ''FLClassCluster'' selector: #materializeReferencesOf:with: isMetaSide: false)' #'2012-04-21T17:36:40.881000001+02:00') #('(RGMethodDefinition className: ''FLFullGlobalMapper'' selector: #cacheGlobalAssociation: isMetaSide: false)' #'2012-04-21T17:36:41.591+02:00') )! !

!ManifestFuelMetalevel class methodsFor: 'meta data' stamp: 'MarianoMartinezPeck 4/21/2012 18:12'!
ruleNotEliminationRuleV1TruePositive
^ #(#('(RGMethodDefinition className: ''FLFullGlobalMapper'' selector: #cacheGlobalAssociation: isMetaSide: false)' #'2012-04-21T18:12:47.675000001+02:00') )! !

!ClassDescription methodsFor: '*FuelMetalevel' stamp: 'MartinDias 7/30/2011 19:23'!
basicInstVarNames: anArray

	instanceVariables := anArray! !

!FLSerializer class methodsFor: '*FuelMetalevel' stamp: 'mariano 5/18/2012 18:50'!
newFull
	| serializer |
	serializer := self new. 
	serializer analyzer useFullMappers.
	^ serializer! !
